(*---------------------------------------------------------------------------
 :Program.     IntuiPointerDemo.mod
 :Author.      Christian Stiens
 :Address.     Snail-Mail:           E-Mail:
 :Address.     Heustiege 2           UUCP: Christian_Stiens@ouzonix.bo.open.de
 :Address.     W-4710 Ldinghausen   FIDO: 2:241/5807
 :Copyright.   public domain
 :Language.    Oberon-2
 :Translator.  Amiga Oberon V2.42d
 :Translator.  Oberon-A 5.13
 :Imports.     IntuiPointer
 :History.     30-Oct-94, [fjc] added conditional compiled code to work
 :History.         under Oberon-A.
---------------------------------------------------------------------------*)

(* $CLEAR OberonA *)

MODULE IntuiPointerDemo;

(* <*IF OberonA THEN*> $IF OberonA *)
  IMPORT
    d:=Dos, ip:=IntuiPointer,
    SYS := SYSTEM,
    u := Utility,
    I := Intuition;

  VAR
    win : I.WindowPtr;
    i   : INTEGER;
(* <*ELSE*> $ELSE *)
  IMPORT
    d:=Dos, ip:=IntuiPointer,
    di:=Display;

  VAR
    win : di.WindowPtr;
    i   : INTEGER;
(* <*END*> $END *)

BEGIN
(* <*IF OberonA THEN*> $IF OberonA *)
  win := I.OpenWindowTagsA (
    NIL,
    I.waTitle,    SYS.ADR ("IntuiPointerDemo"),
    I.waActivate, TRUE,
    u.end );
  IF win # NIL THEN
    d.Delay(30);
    ip.Busy (win);
    d.Delay(30);
    ip.Normal (win);
    d.Delay(30);
    FOR i := 0 TO 16 DO
      d.Delay(20);
      ip.AnimBusy(win,i);
    END;
    ip.Normal(win);
    d.Delay(50);
    I.CloseWindow(win);
  END;
(* <*ELSE*> $ELSE *)
  NEW(win);
  IF di.OpenWindow(win,"IntuiPointerDemo",0,50,640,100,NIL) THEN
    d.Delay(30);
    FOR i := 0 TO 16 DO
      d.Delay(20);
      ip.AnimBusy(win.window,i);
    END;
    ip.Normal(win.window);
    d.Delay(50);
    di.Close(win);
  END;
(* <*END*> $END *)
END IntuiPointerDemo.
