(***************************************************************************

     $RCSfile: Audio.mod $
  Description: Interface to audio.device

   Created by: fjc (Frank Copeland)
    $Revision: 3.8 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  $VER: audio.h 36.3 (29.8.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] Audio;

IMPORT e := Exec;


(*
**
**      audio.device include file
**
*)

CONST

  audioName            * = "audio.device";

  hardChannels         * = 4;

  allocMinPrec         * = -128;
  allocMaxPrec         * = 127;

  free              * = e.nonstd+0;
  setPrec           * = e.nonstd+1;
  finish            * = e.nonstd+2;
  perVol            * = e.nonstd+3;
  lock              * = e.nonstd+4;
  waitCycle         * = e.nonstd+5;
  allocate          * = 32;

  pervol            * = 4;
  syncCycle         * = 5;
  noWait            * = 6;
  writeMessage      * = 7;

  noAllocation    * = -10;
  allocFailed     * = -11;
  channelStolen   * = -12;

TYPE

  IOAudioPtr * = POINTER TO IOAudio;
  IOAudio * = RECORD (e.IORequestBase)
    request *   : e.IORequest;
    allocKey *  : INTEGER;
    data *      : e.APTR;
    length *    : e.ULONG;
    period *    : e.UWORD;
    volume *    : e.UWORD;
    cycles *    : e.UWORD;
    writeMsg *  : e.Message;
  END; (* IOAudio *)


END Audio.


