(***************************************************************************

     $RCSfile: BootBlock.mod $
  Description: floppy BootBlock definition

   Created by: fjc (Frank Copeland)
    $Revision: 3.6 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  $VER: bootblock.h 36.6 (5.11.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] BootBlock;

TYPE

  BootBlockPtr * = POINTER TO BootBlock;
  BootBlock * = RECORD
    id       * : ARRAY 4 OF CHAR;    (* 4 character identifier *)
    chksum   * : LONGINT;            (* boot block checksum (balance) *)
    dosblock * : LONGINT;            (* reserved for DOS patch *)
  END; (* BootBlock *)

CONST

  bootSects    * = 2;       (* 1K bootstrap *)

  idDos        * = "DOS\0";
  idKick       * = "KICK";

  nameDos      * = 444F5300H;      (* 'DOS\0' *)
  nameKick     * = 4B49434BH;      (* 'KICK' *)


END BootBlock.
