(***************************************************************************

     $RCSfile: Cia.mod $
  Description: Interface to ciaa.resource and ciab.resource

   Created by: fjc (Frank Copeland)
    $Revision: 3.8 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] Cia;

IMPORT e := Exec, s := Sets;


(*
**      $VER: cia.h 36.4 (9.1.91)
**
**      Cia resource name strings.
*)

CONST

  ciaaName * = "ciaa.resource";
  ciabName * = "ciab.resource";

(*
**      $VER: ciabase.h 1.2 (16.5.90)
**
**      cia base definitions
*)


(*
 *      There is no public information in CiaBase
 *)


(**-- Resource Base variable --------------------------------------------*)

(*
 *  You have to put a pointer to the cia?.resource here to use the cia
 *  procedures:
 *)

VAR

  base * : e.APTR;


(**-- Resource Functions ------------------------------------------------*)

(*
**      $VER: cia_protos.h 1.7 (19.7.90)
*)


PROCEDURE AddICRVector* [base,-6]
  ( icrBit    [0] : SHORTINT;
    interrupt [9] : e.InterruptPtr )
  : e.InterruptPtr;
PROCEDURE RemICRVector* [base,-12]
  ( icrBit    [0] : LONGINT;
    interrupt [9] : e.InterruptPtr );
PROCEDURE AbleICR* [base,-18]
  ( mask [0] : s.SET8 )
  : s.SET8;
PROCEDURE SetICR* [base,-24]
  ( mask [0] : s.SET8 )
  : s.SET8;

BEGIN base := NIL
END Cia.
