(***************************************************************************

     $RCSfile: FileSysRes.mod $
  Description: Interface to FileSystem.resource

   Created by: fjc (Frank Copeland)
    $Revision: 3.8 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  $VER: filesysres.h 36.4 (3.5.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] FileSysRes;

IMPORT e := Exec, d := Dos, s := Sets;


(*
**      FileSystem.resource description
*)

CONST

  fsrName * = "FileSystem.resource";

TYPE

  FileSysResourcePtr * = POINTER TO FileSysResource;
  FileSysResource * = RECORD (e.NodeBase)
    node *           : e.Node;    (* on resource list *)
    creator *        : e.LSTRPTR; (* name of creator of this resource *)
    fileSysEntries * : e.List;    (* list of FileSysEntry structs *)
  END; (* FileSysResource *)

  FileSysEntryPtr * = POINTER TO FileSysEntry;
  FileSysEntry * = RECORD (e.NodeBase)
    node *       : e.Node;         (* on fsrFileSysEntries list *)
                                   (* lnName is of creator of this entry *)
    dosType *    : e.ULONG;        (* DosType of this FileSys *)
    version *    : e.ULONG;        (* Version of this FileSys *)
    patchFlags * : s.SET32;        (* bits set for those of the following that *)
                                   (*   need to be substituted into a standard *)
                                   (*   device node for this file system: e.g. *)
                                   (*   180H for substitute SegList & GlobalVec *)
    type *       : e.ULONG;        (* device node type: zero *)
    task *       : e.TaskPtr;      (* standard dos "task" field *)
    lock *       : d.FileLockPtr;  (* not used for devices: zero *)
    handler *    : d.BSTR;         (* filename to loadseg (if SegList is null) *)
    stackSize *  : e.ULONG;        (* stacksize to use when starting task *)
    priority *   : LONGINT;        (* task priority when starting task *)
    startup *    : e.BPTR;         (* startup msg: FileSysStartupMsg for disks *)
    segList *    : e.BPTR;         (* code to run to start new task *)
    globalVec *  : e.BPTR;         (* BCPL global vector when starting task *)
    (* no more entries need exist than those implied by fsePatchFlags *)
  END; (* FileSysEntry *)

END FileSysRes.
