(**************************************************************************

     $RCSfile: MathLibrary.mod $
  Description: Interface to mathieee*.library bases

   Created by: fjc (Frank Copeland)
    $Revision: 3.8 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  $VER: mathlibrary.h 1.6 (13.7.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] MathLibrary;

IMPORT e := Exec;

(*
**
**      Data structure returned by OpenLibrary of:
**      mathieeedoubbas.library,mathieeedoubtrans.library
**      mathieeesingbas.library,mathieeesingtrans.library
**
*)

TYPE

  MathIEEEBasePtr * = POINTER TO MathIEEEBase;
  MathIEEEBase * = RECORD (e.LibraryBase)
    libNode * : e.Library;
    reserved : ARRAY 18 OF CHAR;
    taskOpenLib * : PROCEDURE () : LONGINT;
    taskCloseLib * : PROCEDURE () : LONGINT;
    (* This structure may be extended in the future *)
  END; (* MathIEEEBase *)

(*
* Math resources may need to know when a program opens or closes this
* library. The functions TaskOpenLib and TaskCloseLib are called when
* a task opens or closes this library. They are initialized to point to
* local initialization pertaining to 68881 stuff if 68881 resources
* are found. To override the default the vendor must provide appropriate
* hooks in the MathIEEEResource. If specified, these will be called
* when the library initializes.
*)

END MathLibrary.
