(*************************************************************************

     $RCSfile: EAGUI_Macros.mod $
  Description: Macros for EAGUI.library

   Created by: fjc (Frank Copeland)
    $Revision: 1.2 $
      $Author: fjc $
        $Date: 1995/06/04 23:19:47 $

  Oberon-A Interface Copyright  1995, Frank Copeland.
  This file is part of the Oberon-A Library.
  See Oberon-A.doc for conditions of use and distribution.

*************************************************************************)

<* STANDARD- *>
<*$ LongVars+ *>

MODULE EAGUI_Macros;

IMPORT
  SYS := SYSTEM, e := Exec, u := Utility, gfx := Graphics, gt := GadTools,
  ea := EAGUI;

<*$ ReturnChk- StackChk- *>

(*----------------------------------------------------------------------*)

PROCEDURE xHGroup ((* tags [8] : u.TagListPtr *)) : ea.OPTR;
BEGIN (* xHGroup *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_HGROUP,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xHGroup;

PROCEDURE [4] HGroup* ["EAGUI_Macros_xHGroup"]
  ( tags [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] HGroupA* ["EAGUI_Macros_xHGroup"]
  ( tags [8] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xVGroup ((* tags [8] : u.TagListPtr *)) : ea.OPTR;
BEGIN (* xVGroup *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_VGROUP,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xVGroup;

PROCEDURE [4] VGroup* ["EAGUI_Macros_xVGroup"]
  ( tags [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] VGroupA* ["EAGUI_Macros_xVGroup"]
  ( tags [8] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTString
  ((* text [8] : e.LSTRPTR; tags [9] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xGTString *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.stringKind,
                   ea.GTFlags,        {gt.placeTextLeft},
                   ea.GTText,         SYS.REG (8), (* text *)
                   u.more,            SYS.REG (9), (* tags *)
                   u.end ) )
END xGTString;

PROCEDURE [4] GTString* ["EAGUI_Macros_xGTString"]
  ( text [8]   : e.LSTRPTR;
    tags [9].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTStringA* ["EAGUI_Macros_xGTString"]
  ( text [8] : e.LSTRPTR;
    tags [9] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTText
  ((* text [8] : e.LSTRPTR; tags [9] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xGTText *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.textKind,
                   ea.GTFlags,        {gt.placeTextLeft},
                   ea.GTText,         SYS.REG (8), (* text *)
                   u.more,            SYS.REG (9), (* tags *)
                   u.end ) )
END xGTText;

PROCEDURE [4] GTText* ["EAGUI_Macros_xGTText"]
  ( text [8]   : e.LSTRPTR;
    tags [9].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTTextA* ["EAGUI_Macros_xGTText"]
  ( text [8] : e.LSTRPTR;
    tags [9] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTButton
  ((* text [8] : e.LSTRPTR; tags [9] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xGTButton *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.buttonKind,
                   ea.GTFlags,        {gt.placeTextIn},
                   ea.GTText,         SYS.REG (8), (* text *)
                   u.more,            SYS.REG (9), (* tags *)
                   u.end ) )
END xGTButton;

PROCEDURE [4] GTButton* ["EAGUI_Macros_xGTButton"]
  ( text [8]   : e.LSTRPTR;
    tags [9].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTButtonA* ["EAGUI_Macros_xGTButton"]
  ( text [8] : e.LSTRPTR;
    tags [9] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTScroller ((* tags [8] : u.TagListPtr *)) : ea.OPTR;
BEGIN (* xGTScroller *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.scrollerKind,
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xGTScroller;

PROCEDURE [4] GTScroller* ["EAGUI_Macros_xGTScroller"]
  ( tags [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTScrollerA* ["EAGUI_Macros_xGTScroller"]
  ( tags [8] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTSlider ((* tags [8] : u.TagListPtr *)) : ea.OPTR;
BEGIN (* xGTSlider *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.sliderKind,
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xGTSlider;

PROCEDURE [4] GTSlider* ["EAGUI_Macros_xGTSlider"]
  ( tags [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTSliderA* ["EAGUI_Macros_xGTSlider"]
  ( tags [8] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTCheckBox
  ((* text [8] : e.LSTRPTR; tags [9] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xGTCheckBox *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.checkBoxKind,
                   ea.GTFlags,        {gt.placeTextLeft},
                   ea.GTText,         SYS.REG (8), (* text *)
                   u.more,            SYS.REG (9), (* tags *)
                   u.end ) )
END xGTCheckBox;

PROCEDURE [4] GTCheckBox* ["EAGUI_Macros_xGTCheckBox"]
  ( text [8]   : e.LSTRPTR;
    tags [9].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTCheckBoxA* ["EAGUI_Macros_xGTCheckBox"]
  ( text [8] : e.LSTRPTR;
    tags [9] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTInteger
  ((* text [8] : e.LSTRPTR; tags [9] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xGTInteger *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.integerKind,
                   ea.GTFlags,        {gt.placeTextLeft},
                   ea.GTText,         SYS.REG (8), (* text *)
                   u.more,            SYS.REG (9), (* tags *)
                   u.end ) )
END xGTInteger;

PROCEDURE [4] GTInteger* ["EAGUI_Macros_xGTInteger"]
  ( text [8]   : e.LSTRPTR;
    tags [9].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTIntegerA* ["EAGUI_Macros_xGTInteger"]
  ( text [8] : e.LSTRPTR;
    tags [9] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTNumber
  ((* text [8] : e.LSTRPTR; tags [9] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xGTNumber *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.numberKind,
                   ea.GTFlags,        {gt.placeTextLeft},
                   ea.GTText,         SYS.REG (8), (* text *)
                   u.more,            SYS.REG (9), (* tags *)
                   u.end ) )
END xGTNumber;

PROCEDURE [4] GTNumber* ["EAGUI_Macros_xGTNumber"]
  ( text [8]   : e.LSTRPTR;
    tags [9].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTNumberA* ["EAGUI_Macros_xGTNumber"]
  ( text [8] : e.LSTRPTR;
    tags [9] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTListView
  ((* text [8] : e.LSTRPTR; tags [9] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xGTListView *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.listViewKind,
                   ea.GTFlags,        {gt.placeTextLeft},
                   ea.GTText,         SYS.REG (8), (* text *)
                   u.more,            SYS.REG (9), (* tags *)
                   u.end ) )
END xGTListView;

PROCEDURE [4] GTListView* ["EAGUI_Macros_xGTListView"]
  ( text [8]   : e.LSTRPTR;
    tags [9].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTListViewA* ["EAGUI_Macros_xGTListView"]
  ( text [8] : e.LSTRPTR;
    tags [9] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTMX ((* tags [8] : u.TagListPtr *)) : ea.OPTR;
BEGIN (* xGTMX *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.mxKind,
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xGTMX;

PROCEDURE [4] GTMX* ["EAGUI_Macros_xGTMX"]
  ( tags [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTMXA* ["EAGUI_Macros_xGTMX"]
  ( tags [8] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTCycle ((* tags [8] : u.TagListPtr *)) : ea.OPTR;
BEGIN (* xGTCycle *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.cycleKind,
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xGTCycle;

PROCEDURE [4] GTCycle* ["EAGUI_Macros_xGTCycle"]
  ( tags [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTCycleA* ["EAGUI_Macros_xGTCycle"]
  ( tags [8] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xGTPalette ((* tags [8] : u.TagListPtr *)) : ea.OPTR;
BEGIN (* xGTPalette *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.GTType,         gt.paletteKind,
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xGTPalette;

PROCEDURE [4] GTPalette* ["EAGUI_Macros_xGTPalette"]
  ( tags [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] GTPaletteA* ["EAGUI_Macros_xGTPalette"]
  ( tags [8] : u.TagListPtr )
  : ea.OPTR;

(*----------------------------------------------------------------------*)

PROCEDURE xEmptyBox
  ((* weight [1] : LONGINT; tags [8] : u.TagListPtr *))
  : ea.OPTR;
BEGIN (* xEmptyBox *)
  SYS.SETREG ( 0,
    ea.NewObject ( ea.TYPE_GTGADGET,
                   ea.StandardMethod, ea.SM_MINSIZE + ea.SM_BORDER,
                   ea.Weight,         SYS.REG (1), (* weight *)
                   u.more,            SYS.REG (8), (* tags *)
                   u.end ) )
END xEmptyBox;

PROCEDURE [4] EmptyBox* ["EAGUI_Macros_xEmptyBox"]
  ( weight [1]   : LONGINT;
    tags   [8].. : u.Tag )
  : ea.OPTR;

PROCEDURE [4] EmptyBoxA* ["EAGUI_Macros_xEmptyBox"]
  ( weight [1] : LONGINT;
    tags   [8] : u.TagListPtr )
  : ea.OPTR;

END EAGUI_Macros.
